# Mineral Waters
# Vladimir Batagelj  October 27, 2013 / October 9, 2009
# ------------------------------------------------------------------------------
# setwd("C:/Users/batagelj/test/R/mineral")
# mineral()

initial <- function(s,term) substr(s,1,regexpr(term,s[1])[1]-1)

# http://www.mineralwaters.org/index.php?func=disp&parval=4138

mineral <- function(){
  library(XML)
  dat <- file("waters.dat","w")
  cat('*** Mineral waters:',date(),'\n*** from http://www.mineralwaters.org/\n')
  cat('*** Mineral waters:',date(),'\n*** from http://www.mineralwaters.org/\n',file=dat)
  url <- 'http://www.mineralwaters.org/index.php?func=disp&parval='
  ind <- 1:4138
#  ind <- c(173,306,956,1255,1347,2044,2079,2660,3659) # strange chars
  for(p in ind){
    pa <- paste(url,p,sep='')
    st <- readLines(con<-url(pa),warn=FALSE); close(con)
    dw <- htmlParse(st)
    ti <- dw['//h2']
    if(length(ti)==0){
      cat('***',p,'Missing\n'); flush.console()
      next
    }
    tit <- xmlValue(ti[[1]])
    coun <- xmlValue(dw['//p/b'][[5]])   
    i <- grep('Country: ',st,ignore.case=TRUE)
    s <- unlist(strsplit(st[i],'Place of Source</i>: '))
    plac <- initial(s[2],'</p>')
    cat('***',p,tit,'\n'); flush.console()
    cat('N',p,'\n',sep='|',file=dat)
    cat('W',tit,'\n',sep='|',file=dat)
    cat('C',coun,'\n',sep='|',file=dat)
    cat('P',plac,'\n',sep='|',file=dat)
    flush(dat)
    j <- grep('No data from analysis available',st,ignore.case=TRUE)
    if(length(j)!=0) next
    v <- st[i]; i <- regexpr('<table',v)
    v <- substr(v,i+6,nchar(v))
    i <- regexpr('<table',v); j <- regexpr('</table',v)
    v <- substr(v,i+6,j-1)
    if(nchar(v)<15) next
    t <- unlist(strsplit(v,'<tr><td>'))
    for(k in 2:length(t)){
      u <- unlist(strsplit(t[k],'</td><td></td><td>'))
      q <- unlist(strsplit(initial(u[2],'</td>'),'  '))
      e <- u[1]; i <- regexpr('\">',e)
      if(i>0) e <- initial(substr(e,i+2,nchar(e)),'</a>')
#     cat('E',e,q[1],q[2],'\n',sep='|')
      cat('E',e,q[1],q[2],'\n',sep='|',file=dat)
      flush(dat)
    }
  }
  close(dat)
}



