# Mineral Waters
# Vladimir Batagelj  October 27, 2013 / October 9, 2009
# ------------------------------------------------------------------------------
# setwd("C:/Users/batagelj/test/R/mineral")
# source("C:\\Users\\batagelj\\test\\R\\mineral\\mineralWaters.R")
# mineral()

initial <- function(s,term) substr(s,1,regexpr(term,s[1])[1]-1)

# 	

mineral <- function(){
  library(XML)
  dat <- file("waters.dat","w")
  cat('*** Mineral waters:',date(),'\n*** from http://www.mineralwaters.org/\n')
  cat('*** Mineral waters:',date(),'\n*** from http://www.mineralwaters.org/\n',file=dat)
  url <- 'http://www.mineralwaters.org/index.php?func=disp&parval='
  ind <- 1:4138
#  ind <- c(173,306,956,1255,1347,2044,2079,2660,3659) # strange chars
  for(p in ind){
    pa <- paste(url,p,sep='')
    st <- readLines(con<-url(pa),warn=FALSE); close(con)
    dw <- htmlParse(st)
    ti <- dw['//h2']
    if(length(ti)==0){
      cat('***',p,'Missing\n'); flush.console()
      next
    }
    tit <- xmlValue(ti[[1]]); Encoding(tit) <- "UTF-8"
    coun <- xmlValue(dw['//p/b'][[5]])
    pl <- dw['//table/tr/td/table/tr/td/p[i]']
    plac <- NA
    if(length(pl)>0){
      pla <- xmlValue(pl[[1]]); Encoding(pla) <- "UTF-8" 
      if(substr(pla,1,4)=="Name") {
         plac <- substr(pla,26,nchar(pla))
      } else if(length(pl)>1) { 
         pla <- xmlValue(pl[[2]]); Encoding(pla) <- "UTF-8" 
         if(substr(pla,1,4)=="Name") plac <- substr(pla,26,nchar(pla))
      }     
    } 
    cat('***',p,tit,'\n'); flush.console()
    cat(p,tit,coun,plac,"",sep='|',file=dat)
    j <- grep('No data from analysis available',st,ignore.case=TRUE)
    if(length(j)!=0) {cat('\n',file=dat); flush(dat); next}
    i <- grep('Country: ',st,ignore.case=TRUE)
    v <- st[i]; i <- regexpr('<table',v)
    v <- substr(v,i+6,nchar(v))
    i <- regexpr('<table',v); j <- regexpr('</table',v)
    v <- substr(v,i+6,j-1)
    if(nchar(v)<15) {cat('\n',file=dat); flush(dat); next}
    t <- unlist(strsplit(v,'<tr><td>'))
    for(k in 2:length(t)){
      u <- unlist(strsplit(t[k],'</td><td></td><td>'))
      q <- unlist(strsplit(initial(u[2],'</td>'),'  '))
      e <- u[1]; i <- regexpr('\">',e)
      if(i>0) e <- initial(substr(e,i+2,nchar(e)),'</a>')
      cat(e,q[1],q[2],"",sep='|',file=dat)
    }
    cat('\n',file=dat); flush(dat)
  }
  cat('*** Finished:',date(),'\n',file=dat)
  close(dat)
  cat('*** Finished:',date(),'\n\n')
}



